# esp32api/FlagCode.py

class FlagCode:
    # 4系列
    F_SENSOR_TYPE1 = "AA 0F 01 C5 80 EE"  # 终端读取模块信息命令

    F_SENSOR_NUM2 = "AA 01 01 C1 E0 EE"  # 终端发送浓度数据读取命令ppm
    F_SENSOR_MODULE_ZERO3 = "AA 02 01 C1 10 EE"  # 终端发送模块校零命令
    F_SENSOR_MODULE_ZERO3_TRUE = "AA 02 01 10 D0 5C EE"

    F_SENSOR_MODULE_CALIBRATION4 = "AA 03 01 C0 80 EE"  # 终端发送模块标定命令
    F_SENSOR_MODULE_CALIBRATION4_TRUE = "AA 03 01 10 81 9C EE"
    F_SENSOR_UPDATE_ADDRESS5 = "AA 04 02 82 B1 EE"  # 终端修改模块地址命令
    F_SENSOR_UPDATE_ADDRESS5_TRUE = "AA 04 02 10 30 AD EE"
    F_SENSOR_UPDATE_CONCENTRATION6 = "AA 05 01 01 F4 51 3F EE"  # 终端发送修改模块标气浓度命令
    F_SENSOR_UPDATE_CONCENTRATION6_TRUE = "AA 05 01 10 01 F4 E8 2E EE"

    # 7系列指令
    S_SENSOR_TYPE1 = "3A 10 01 00 00 01 00 00 82 B0"  # 类型

    S_SENSOR_NUM2 = "3A 10 03 00 00 02 00 00 73 52"  # 单位μg/m³
    S_SENSOR_NUM3 = "3A 10 03 00 02 02 00 00 72 EA"  # 单位ppb
    S_SENSOR_TEMPERATURE4 = "3A 10 03 00 04 01 00 00 82 62"  # 读取温度传感器数据 (单位为°C)
    S_SENSOR_HUMIDITY5 = "3A 10 03 00 05 01 00 00 83 9E"  # 读取湿度传感器数据 (单位为%RH)
    S_SENSOR_PARAMS6 = "3A 10 03 00 00 06 00 00 32 93"  # 读取多个参数 (地址0000 ~ 0005)
    S_SENSOR_CHECK7 = "3A 10 08 00 0A F9"  # 校验错误应答
    S_SENSOR_ZERO_CALIBRATION8 = "3A 10 07 00 00 01 00 00 82 D6"  # 零点标定
    S_SENSOR_SENSITIVITY_CALIBRATION9 = "3A 10 09 00 00 01 00 0A 03 FF"  # 灵敏度标定  D为00 0A 即：使用10PPM浓度气体进行标定